function [est_results, overall] = convertToEstResults(x, number_of_types, baseline_estimates, Sanc, Sunanc)

	overall = zeros(1,Sanc+Sunanc+2);
	est_results(1:number_of_types,1:Sanc+Sunanc+5) = NaN;
	for types=1:number_of_types,
		if types < number_of_types,
			prob_of_type = x(types);
		end;
		if types == number_of_types,
			prob_of_type = 1-sum(x(1:number_of_types-1));
		end;

		parameter_order = [1:Sanc Sanc+Sunanc+1 Sanc+1:Sanc+Sunanc];
		est_results(types,:) = [x(number_of_types-1+(Sanc+Sunanc+1)*(types-1)+parameter_order) 1-sum(x(number_of_types-1+(Sanc+Sunanc+1)*(types-1)+parameter_order)) prob_of_type  x(number_of_types-1+(Sanc+Sunanc+1)*number_of_types+types) types];
		overall = overall + est_results(types,Sanc+Sunanc+3)*est_results(types,1:Sanc+Sunanc+2);
	end;
	
	est_results = sortrows(est_results,[-(Sanc+Sunanc+3)]);

	if size(baseline_estimates,1) > 0,

		est_results(:,Sanc+Sunanc+5+1:Sanc+Sunanc+5+number_of_types) = NaN;
		for types1=1:number_of_types,
			for types2=1:number_of_types,
				est_results(types1,Sanc+Sunanc+5+types2) = norm(est_results(types1,1:Sanc+Sunanc+4)-baseline_estimates(types2,1:Sanc+Sunanc+4));
			end;
		end;

		possible_perms = perms(linspace(1,number_of_types, number_of_types));

		perms_distance(1:size(possible_perms,1),1:2) = 0;
		for possible_perms_index=1:size(possible_perms,1),
			for types=1:number_of_types,
				perms_distance(possible_perms_index, 1) = perms_distance(possible_perms_index, 1) + est_results(types,Sanc+Sunanc+5+possible_perms(possible_perms_index,types));
			end;
			perms_distance(possible_perms_index, 2) = possible_perms_index;
		end;

		perms_distance = sortrows(perms_distance, 1);
		minimizing_perm = possible_perms(perms_distance(1,2),:);

		inverse_perm(1:number_of_types) = NaN;
		for types=1:number_of_types,
			inverse_perm(types) = find(minimizing_perm == types);
		end;
		est_results = est_results(inverse_perm,:);
		est_results = est_results(:,1:Sanc+Sunanc+4);

	end;
	

end