% generates fake data to test the estimation code

clear variables
RandStream.setGlobalStream(RandStream('mt19937ar','Seed', 1));

N = 350;
g = 16;

% games have the same structure as the real experimental data from CGC
	own_ps = [0.7 0.5 1.5 1.3 0.5 0.7 0.7 0.7 0.5 0.7 1.3 1.3 1.5 1.3 1.5 1.5];
	mins = [100 100 300 300 100 300 300 100 100 300 300 300 100 100 100 100];
	maxs = [500 900 500 900 900 900 500 500 900 500 900 900 500 900 900 500];
	anc_guess{1} = [350 150 200 350 500 520 780 780 150 500 350 780 350 600 210 450];
	anc_guess{2} = [105 175 175 300 500 650 900 900 250 225 546 455 420 525 315 315];
	anc_guess{3} = [122.5 100 150 300 500 650 900 900 112.5 375 318.5 709.8 367.5 630 220.5 472.5];
	
	unanc_lower{1} = [100 100 150 300 450 390 390 390 100 150 300 390 300 450 100 150];
	unanc_upper{1} = [500 250 250 500 500 650 900 900 250 500 630 900 500 750 350 500];	
	
% rearrange games to be in the same order as CGC
	rearrange = [1 9 2 10 3 11 4 12 5 13 6 14 7 15 8 16];
		
	own_ps = own_ps(rearrange);
	mins = mins(rearrange);
	maxs = maxs(rearrange);
	
% parameters of the generated data DGP
	type(1:60) = 1;
	type(61:350) = 2;
		
	%                  1anc 2anc 0un 1un
	type_actions{1} = [0.85 0.10 0.05 0];
	type_actions{2} = [0.50 0.15 0.20 0.15];
	
	type_mistake{1} = [0.1 0.9];
	type_mistake{2} = [0.01 0.99];
	
	type_mistake_rat{1} = 2.5/200;
	type_mistake_rat{2} = 2.5/200;
	
% generate the fake data
for i=1:N,

	indices_vec(i) = i;

	for g=1:16,
	
		desired = mnrnd(1,type_actions{type(i)});
		mistake = mnrnd(1,type_mistake{type(i)});
		
		curaction = 0;
		
		if isequal(desired,[1 0 0 0]) && isequal(mistake,[0 1]),
			curaction = anc_guess{1}(g);
		elseif isequal(desired,[1 0 0 0]) && isequal(mistake,[1 0]),
			curaction = unifrnd(max(mins(g),anc_guess{1}(g)-type_mistake_rat{type(i)}*(maxs(g)-mins(g))),min(maxs(g),anc_guess{1}(g)+type_mistake_rat{type(i)}*(maxs(g)-mins(g))));
		elseif isequal(desired,[0 1 0 0]) && isequal(mistake,[0 1]),
			curaction = anc_guess{2}(g);
		elseif isequal(desired,[0 1 0 0]) && isequal(mistake,[1 0]),
			curaction = unifrnd(max(mins(g),anc_guess{2}(g)-type_mistake_rat{type(i)}*(maxs(g)-mins(g))),min(maxs(g),anc_guess{2}(g)+type_mistake_rat{type(i)}*(maxs(g)-mins(g))));
		elseif isequal(desired,[0 0 1 0]),
			curaction = unifrnd(mins(g), maxs(g));
		elseif isequal(desired,[0 0 0 1]),
			curaction = unifrnd(unanc_lower{1}(g), unanc_upper{1}(g));
		end;
		
		action(i,g) = curaction;
			
	end;

end;

action = [indices_vec' action];
csvwrite('generated.csv', action);