function [likelihood, grad, likelihood_of_i_from_type] = mixture_lik_wrapper(data, x, special_choices, number_of_types, mistake_size, Sanc, Sunanc)

	dist_over_types(1:number_of_types) = 0;
	dist_over_types = x(1:number_of_types-1);
	dist_over_types(number_of_types) = 1 - sum(x(1:number_of_types-1));

	dist_over_solns(1:number_of_types, 1:Sanc+Sunanc+2) = 0;	
	for type_index = 1:number_of_types,
		for action = 1:Sanc,
			dist_over_solns(type_index, action) = x(number_of_types - 1 + (Sanc+Sunanc+1)*(type_index-1) + action);
		end;
		for action = 1:Sunanc,
			dist_over_solns(type_index, Sanc + action) = x(number_of_types - 1 + (Sanc+Sunanc+1)*(type_index-1) + Sanc + action);
		end;
		dist_over_solns(type_index, Sanc+Sunanc+1) = x(number_of_types - 1 + (Sanc+Sunanc+1)*(type_index-1) + Sanc+Sunanc + 1);
		dist_over_solns(type_index, Sanc+Sunanc+2) = 1 - sum(dist_over_solns(type_index,1:Sanc+Sunanc+1));
	end;

	prob_of_mistakes(1:number_of_types) = 0;	
	for type_index = 1:number_of_types,
		prob_of_mistakes(type_index) = x(number_of_types - 1 + (Sanc+Sunanc+1)*number_of_types + type_index);
	end;
	
	[likelihood, grad, likelihood_of_i_from_type] = mixture_lik(data, dist_over_types, prob_of_mistakes, dist_over_solns, special_choices, number_of_types, mistake_size, Sanc, Sunanc);
	
end